# Generated by Django 3.2.6 on 2022-01-27 08:20

from django.db import migrations, models


def migrate_enum_values_to_single_enum(apps, schema_editor):
    AppExtension = apps.get_model("app", "AppExtension")
    app_extensions = AppExtension.objects.all()
    for extension in app_extensions:
        if extension.type == "overview":
            if extension.target == "more_actions":
                extension.mount = "product_overview_more_actions"
            else:
                extension.mount = "product_overview_create"
        else:
            extension.mount = "product_details_more_actions"
        # simple save as there aren't a lot of app extensions.
        extension.save()


class Migration(migrations.Migration):

    dependencies = [
        ("app", "0005_appextension"),
    ]
    operations = [
        migrations.AddField(
            model_name="appextension",
            name="mount",
            field=models.CharField(
                choices=[
                    ("product_overview_create", "product_overview_create"),
                    ("product_overview_more_actions", "product_overview_more_actions"),
                    ("product_details_more_actions", "product_details_more_actions"),
                    ("navigation_catalog", "navigation_catalog"),
                    ("navigation_orders", "navigation_orders"),
                    ("navigation_customers", "navigation_customers"),
                    ("navigation_discounts", "navigation_discounts"),
                    ("navigation_translations", "navigation_translations"),
                    ("navigation_pages", "navigation_pages"),
                ],
                max_length=256,
                null=True,
            ),
        ),
        migrations.RunPython(
            migrate_enum_values_to_single_enum, migrations.RunPython.noop
        ),
    ]
